#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
void ATL_dJIK48x48x48NN0x0x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=48, NB=48, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=1, ku=2, pf=0
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + 48;
   const double *stN = B + (((ldb) << 5)+((ldb) << 4));
   const int incAk = (lda);
   const int incAm = 6 - (((lda) << 5)+((lda) << 4)), incAn = -48;
   #define incBk 2
   const int incBm = -48, incBn = (ldb);
   #define incAk0 incAk
   const int incBk0 = ((incBk) >> 1);
   #define incCm 6
   const int incCn = (ldc) - 48;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0;
   register double m0, m1, m2, m3;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC3_0 = pC0[3];
         rC3_0 *= rA0;
         rC4_0 = pC0[4];
         rC4_0 *= rA0;
         rC5_0 = pC0[5];
         rC5_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rA5 = pA0[5];
         m0 = rA0 * rB0;
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;

         for (k=0; k < 46; k += 2) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA4 * rB0;
            rC1_0 += m1;
            m1 = rA5 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rC2_0 += m2;
            m2 = rA0 * rB0;
            rC3_0 += m3;
            m3 = rA1 * rB0;
            rC4_0 += m0;
            m0 = rA2 * rB0;
            rC5_0 += m1;
            m1 = rA3 * rB0;
            rC0_0 += m2;
            m2 = rA4 * rB0;
            rC1_0 += m3;
            m3 = rA5 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rC2_0 += m0;
            m0 = rA0 * rB0;
            rC3_0 += m1;
            m1 = rA1 * rB0;
            rC4_0 += m2;
            m2 = rA2 * rB0;
            rC5_0 += m3;
            m3 = rA3 * rB0;
            pB0 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA4 * rB0;
         rC1_0 += m1;
         m1 = rA5 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rA5 = pA0[5];
         rC2_0 += m2;
         m2 = rA0 * rB0;
         rC3_0 += m3;
         m3 = rA1 * rB0;
         rC4_0 += m0;
         m0 = rA2 * rB0;
         rC5_0 += m1;
         m1 = rA3 * rB0;
         pB0 += (incBk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA4 * rB0;
         rC1_0 += m3;
         m3 = rA5 * rB0;
         pA0 += incAk0;
         rC2_0 += m0;
         rC3_0 += m1;
         rC4_0 += m2;
         rC5_0 += m3;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
