#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
void ATL_dJIK48x48x48TT0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=48, NB=48, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=1, ku=2, pf=0
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (((lda) << 5)+((lda) << 4));
   const double *stN = B + 48;
   #define incAk 2
   const int incAm = ((((lda) << 2)+((lda) << 1)) - 48), incAn = -(((lda) << 5)+((lda) << 4));
   const int incBk = (ldb), incBm = -(((ldb) << 5)+((ldb) << 4));
   #define incBn 1
   const int incAk0 = ((incAk) >> 1);
   #define incBk0 incBk
   #define incCm 6
   const int incCn = (ldc) - 48;
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda);
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0;
   register double m0, m1, m2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rA5 = *pA5;
         m0 = rA0 * rB0;
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;

/*
 *       Peel first 2 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA3 * rB0;
         rC1_0 = m1;
         m1 = rA4 * rB0;
         rC2_0 = m2;
         m2 = rA5 * rB0;
         pB0 += incBk;
         rA0 = pA0[1];
         rB0 = *pB0;
         rA1 = pA1[1];
         rA2 = pA2[1];
         rA3 = pA3[1];
         rA4 = pA4[1];
         rA5 = pA5[1];
         rC3_0 = m0;
         m0 = rA0 * rB0;
         rC4_0 = m1;
         m1 = rA1 * rB0;
         rC5_0 = m2;
         m2 = rA2 * rB0;
         rC0_0 += m0;
         m0 = rA3 * rB0;
         rC1_0 += m1;
         m1 = rA4 * rB0;
         rC2_0 += m2;
         m2 = rA5 * rB0;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rA2 = pA2[2];
         rA3 = pA3[2];
         rA4 = pA4[2];
         rA5 = pA5[2];
         rC3_0 += m0;
         m0 = rA0 * rB0;
         rC4_0 += m1;
         m1 = rA1 * rB0;
         rC5_0 += m2;
         m2 = rA2 * rB0;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 44; k += 2) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA3 * rB0;
            rC1_0 += m1;
            m1 = rA4 * rB0;
            rC2_0 += m2;
            m2 = rA5 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rA1 = pA1[1];
            rA2 = pA2[1];
            rA3 = pA3[1];
            rA4 = pA4[1];
            rA5 = pA5[1];
            rC3_0 += m0;
            m0 = rA0 * rB0;
            rC4_0 += m1;
            m1 = rA1 * rB0;
            rC5_0 += m2;
            m2 = rA2 * rB0;
            rC0_0 += m0;
            m0 = rA3 * rB0;
            rC1_0 += m1;
            m1 = rA4 * rB0;
            rC2_0 += m2;
            m2 = rA5 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rA1 = pA1[2];
            rA2 = pA2[2];
            rA3 = pA3[2];
            rA4 = pA4[2];
            rA5 = pA5[2];
            rC3_0 += m0;
            m0 = rA0 * rB0;
            rC4_0 += m1;
            m1 = rA1 * rB0;
            rC5_0 += m2;
            m2 = rA2 * rB0;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pA4 += incAk;
            pA5 += incAk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA3 * rB0;
         rC1_0 += m1;
         m1 = rA4 * rB0;
         rC2_0 += m2;
         m2 = rA5 * rB0;
         pB0 += incBk;
         rA0 = pA0[1];
         rB0 = *pB0;
         rA1 = pA1[1];
         rA2 = pA2[1];
         rA3 = pA3[1];
         rA4 = pA4[1];
         rA5 = pA5[1];
         rC3_0 += m0;
         m0 = rA0 * rB0;
         rC4_0 += m1;
         m1 = rA1 * rB0;
         rC5_0 += m2;
         m2 = rA2 * rB0;
         pA0 += (incAk0);
         pA1 += (incAk0);
         pA2 += (incAk0);
         pA3 += (incAk0);
         pA4 += (incAk0);
         pA5 += (incAk0);
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA3 * rB0;
         rC1_0 += m1;
         m1 = rA4 * rB0;
         rC2_0 += m2;
         m2 = rA5 * rB0;
         pB0 += incBk0;
         rC3_0 += m0;
         rC4_0 += m1;
         rC5_0 += m2;
         pA0 += incAk0;
         pA1 += incAk0;
         pA2 += incAk0;
         pA3 += incAk0;
         pA4 += incAk0;
         pA5 += incAk0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pA5 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
